
_Send_I2C:

;LCD_I2C_Soft_07.mbas,30 :: 		sub procedure Send_I2C (dim dat as byte)      ' Test I2C for LCD
;LCD_I2C_Soft_07.mbas,32 :: 		Soft_I2C_Start
	CALL       _Soft_I2C_Start+0
;LCD_I2C_Soft_07.mbas,33 :: 		Soft_I2C_Write(Waddr)      ' send address via I2C (device address + W)
	MOVLW      78
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;LCD_I2C_Soft_07.mbas,34 :: 		Soft_I2C_Write(dat)
	MOVF       FARG_Send_I2C_dat+0, 0
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;LCD_I2C_Soft_07.mbas,35 :: 		Soft_I2C_stop
	CALL       _Soft_I2C_Stop+0
;LCD_I2C_Soft_07.mbas,36 :: 		end sub
L_end_Send_I2C:
	RETURN
; end of _Send_I2C

_Read_I2C:

;LCD_I2C_Soft_07.mbas,38 :: 		sub function Read_I2C as byte
;LCD_I2C_Soft_07.mbas,39 :: 		Soft_I2C_Start
	CALL       _Soft_I2C_Start+0
;LCD_I2C_Soft_07.mbas,40 :: 		Soft_I2C_Write(Raddr)      ' send address via I2C (device address + W)
	MOVLW      79
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;LCD_I2C_Soft_07.mbas,41 :: 		Read_I2C=Soft_I2C_Read(0)
	CLRF       FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      Read_I2C_local_result+0
;LCD_I2C_Soft_07.mbas,42 :: 		Soft_I2C_stop
	CALL       _Soft_I2C_Stop+0
;LCD_I2C_Soft_07.mbas,43 :: 		end sub
	MOVF       Read_I2C_local_result+0, 0
	MOVWF      R0+0
L_end_Read_I2C:
	RETURN
; end of _Read_I2C

_send_CReg:

;LCD_I2C_Soft_07.mbas,53 :: 		dim hi_n, lo_n  as byte
;LCD_I2C_Soft_07.mbas,54 :: 		hi_n = cmd and 0xF0       lo_n=(cmd and 0x0F) << 4
	MOVLW      240
	ANDWF      FARG_send_CReg_cmd+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      send_CReg_hi_n+0
	MOVLW      15
	ANDWF      FARG_send_CReg_cmd+0, 0
	MOVWF      send_CReg_lo_n+0
	RLF        send_CReg_lo_n+0, 1
	BCF        send_CReg_lo_n+0, 0
	RLF        send_CReg_lo_n+0, 1
	BCF        send_CReg_lo_n+0, 0
	RLF        send_CReg_lo_n+0, 1
	BCF        send_CReg_lo_n+0, 0
	RLF        send_CReg_lo_n+0, 1
	BCF        send_CReg_lo_n+0, 0
;LCD_I2C_Soft_07.mbas,55 :: 		send_I2C(hi_n or 0x0C) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=0
	MOVLW      12
	IORWF      R1+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,56 :: 		send_I2C(hi_n or 0x80) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=0
	MOVLW      128
	IORWF      send_CReg_hi_n+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,57 :: 		send_I2C(lo_n or 0x0C) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=0
	MOVLW      12
	IORWF      send_CReg_lo_n+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,58 :: 		send_I2C(lo_n or 0x80) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=0
	MOVLW      128
	IORWF      send_CReg_lo_n+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,59 :: 		end sub
L_end_send_CReg:
	RETURN
; end of _send_CReg

_send_DReg:

;LCD_I2C_Soft_07.mbas,62 :: 		dim hi_n, lo_n  as byte
;LCD_I2C_Soft_07.mbas,63 :: 		hi_n = dat and 0xF0       lo_n=(dat and 0x0F) << 4
	MOVLW      240
	ANDWF      FARG_send_DReg_dat+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      send_DReg_hi_n+0
	MOVLW      15
	ANDWF      FARG_send_DReg_dat+0, 0
	MOVWF      send_DReg_lo_n+0
	RLF        send_DReg_lo_n+0, 1
	BCF        send_DReg_lo_n+0, 0
	RLF        send_DReg_lo_n+0, 1
	BCF        send_DReg_lo_n+0, 0
	RLF        send_DReg_lo_n+0, 1
	BCF        send_DReg_lo_n+0, 0
	RLF        send_DReg_lo_n+0, 1
	BCF        send_DReg_lo_n+0, 0
;LCD_I2C_Soft_07.mbas,64 :: 		send_I2C(hi_n or 0x0D) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=1
	MOVLW      13
	IORWF      R1+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,65 :: 		send_I2C(hi_n or 0x09) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=1
	MOVLW      9
	IORWF      send_DReg_hi_n+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,66 :: 		send_I2C(lo_n or 0x0D) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=1
	MOVLW      13
	IORWF      send_DReg_lo_n+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,67 :: 		send_I2C(lo_n or 0x09) ' portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=1
	MOVLW      9
	IORWF      send_DReg_lo_n+0, 0
	MOVWF      FARG_Send_I2C_dat+0
	CALL       _Send_I2C+0
;LCD_I2C_Soft_07.mbas,68 :: 		end sub
L_end_send_DReg:
	RETURN
; end of _send_DReg

_goto_yx:

;LCD_I2C_Soft_07.mbas,70 :: 		sub procedure goto_yx(dim y, x as byte) ' y = 1..4 lines : x = 1 .. 20 chars
;LCD_I2C_Soft_07.mbas,71 :: 		x = (x-1) mod 20
	DECF       FARG_goto_yx_x+0, 0
	MOVWF      R0+0
	MOVLW      20
	MOVWF      R4+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      FARG_goto_yx_x+0
;LCD_I2C_Soft_07.mbas,74 :: 		case 1  send_CReg(0x80 + 0x00 + x) ' first line   @ 0x00
	MOVF       FARG_goto_yx_y+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__goto_yx8
	MOVF       FARG_goto_yx_x+0, 0
	ADDLW      128
	MOVWF      FARG_send_CReg_cmd+0
	CALL       _send_CReg+0
	GOTO       L__goto_yx5
L__goto_yx8:
;LCD_I2C_Soft_07.mbas,75 :: 		case 2  send_CReg(0x80 + 0x40 + x) ' second line  @ 0x40
	MOVF       FARG_goto_yx_y+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__goto_yx11
	MOVF       FARG_goto_yx_x+0, 0
	ADDLW      192
	MOVWF      FARG_send_CReg_cmd+0
	CALL       _send_CReg+0
	GOTO       L__goto_yx5
L__goto_yx11:
;LCD_I2C_Soft_07.mbas,76 :: 		case 3  send_CReg(0x80 + 0x14 + x) ' third line   @ 0x14
	MOVF       FARG_goto_yx_y+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__goto_yx14
	MOVF       FARG_goto_yx_x+0, 0
	ADDLW      148
	MOVWF      FARG_send_CReg_cmd+0
	CALL       _send_CReg+0
	GOTO       L__goto_yx5
L__goto_yx14:
;LCD_I2C_Soft_07.mbas,77 :: 		case 4  send_CReg(0x80 + 0x54 + x) ' fourth line  @ 0x54
	MOVF       FARG_goto_yx_y+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__goto_yx17
	MOVF       FARG_goto_yx_x+0, 0
	ADDLW      212
	MOVWF      FARG_send_CReg_cmd+0
	CALL       _send_CReg+0
	GOTO       L__goto_yx5
L__goto_yx17:
L__goto_yx5:
;LCD_I2C_Soft_07.mbas,79 :: 		end sub
L_end_goto_yx:
	RETURN
; end of _goto_yx
